/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

// CTLogApplyConfiguration represents an declarative configuration of the CTLog type for use
// with apply.
type CTLogApplyConfiguration struct {
	URL         *string `json:"url,omitempty"`
	RekorPubKey *string `json:"pubkey,omitempty"`
	IgnoreSCT   *bool   `json:"ignoreSCT,omitempty"`
	IgnoreTlog  *bool   `json:"ignoreTlog,omitempty"`
}

// CTLogApplyConfiguration constructs an declarative configuration of the CTLog type for use with
// apply.
func CTLog() *CTLogApplyConfiguration {
	return &CTLogApplyConfiguration{}
}

// WithURL sets the URL field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the URL field is set to the value of the last call.
func (b *CTLogApplyConfiguration) WithURL(value string) *CTLogApplyConfiguration {
	b.URL = &value
	return b
}

// WithRekorPubKey sets the RekorPubKey field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the RekorPubKey field is set to the value of the last call.
func (b *CTLogApplyConfiguration) WithRekorPubKey(value string) *CTLogApplyConfiguration {
	b.RekorPubKey = &value
	return b
}

// WithIgnoreSCT sets the IgnoreSCT field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the IgnoreSCT field is set to the value of the last call.
func (b *CTLogApplyConfiguration) WithIgnoreSCT(value bool) *CTLogApplyConfiguration {
	b.IgnoreSCT = &value
	return b
}

// WithIgnoreTlog sets the IgnoreTlog field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the IgnoreTlog field is set to the value of the last call.
func (b *CTLogApplyConfiguration) WithIgnoreTlog(value bool) *CTLogApplyConfiguration {
	b.IgnoreTlog = &value
	return b
}
